<?php

define("MB", 1048576);

// date_default_timezone_get("Europe/Istanbul");
// date_default_timezone_get("Asia/Baghdad");

function filterRequest($requestname)
{
    return  htmlspecialchars(strip_tags($_POST[$requestname]));
}

function getAllData($table, $where = null, $values = null, $json = true)
{
    global $con;
    $data = array();
    if ($where == null) {
        $stmt = $con->prepare("SELECT  * FROM $table ");
    } else {
        $stmt = $con->prepare("SELECT  * FROM $table WHERE $where ");
    }
    $stmt->execute($values);
    $data = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $count  = $stmt->rowCount();
    if ($json == true) {
        if ($count > 0) {
            $resJson = array("status" => "success", "data" => $data);
            echo json_encode($resJson, JSON_UNESCAPED_UNICODE);
        } else {
            $resJson = array("status" => "failure");
            echo json_encode($resJson, JSON_UNESCAPED_UNICODE);
        }
        return $count;
    } else {
        if ($count > 0) {
            return $data;
        } else {
            return json_encode(array("status" => "failure"), JSON_UNESCAPED_UNICODE);
        }
    }
}

function countData($countOfRow ,$table, $where = null)
{
    global $con;
    // $data = array();
    $stmt = $con->prepare("SELECT COUNT($countOfRow) FROM $table WHERE $where ");
    $stmt->execute();
    $data = $stmt->rowCount();
    // $data  = $stmt->rowCount();
    if ($data > 0) {
        echo (array("status" => "success", "data" => $data));
    } else {
        echo (array("status" => "failure"));
    }
    echo $data;
}


function getData($table, $where = null, $values = null)
{
    global $con;
    $data = array();
    $stmt = $con->prepare("SELECT  * FROM $table WHERE $where ");
    $stmt->execute($values);
    $data = $stmt->fetch(PDO::FETCH_ASSOC);
    $count  = $stmt->rowCount();
    if ($count > 0) {
        echo json_encode(array("status" => "success", "data" => $data));
    } else {
        echo json_encode(array("status" => "failure"));
    }
    return $count;
}





function insertData($table, $data, $json = true)
{
    global $con;
    foreach ($data as $field => $v)
        $ins[] = ':' . $field;
    $ins = implode(',', $ins);
    $fields = implode(',', array_keys($data));
    $sql = "INSERT INTO $table ($fields) VALUES ($ins)";

    $stmt = $con->prepare($sql);
    foreach ($data as $f => $v) {
        $stmt->bindValue(':' . $f, $v);
    }
    $stmt->execute();
    $count = $stmt->rowCount();
    if ($json == true) {
        if ($count > 0) {
            echo json_encode(array("status" => "success"));
        } else {
            echo json_encode(array("status" => "failure"));
        }
    }
    return $count;
}


function updateData($table, $data, $where, $json = true)
{
    if (is_array($data) || is_object($data))
    {
        global $con;
        $cols = array();
        $vals = array();
            foreach ($data as $key => $val) {
                $vals[] = "$val";
                $cols[] = "`$key` =  ? ";
            }
        
        $sql = "UPDATE $table SET " . implode(', ', $cols) . " WHERE $where";

        $stmt = $con->prepare($sql);
        $stmt->execute($vals);
        $count = $stmt->rowCount();
        if ($json == true) {
            if ($count > 0) {
                echo json_encode(array("status" => "success"));
            } else {
                echo json_encode(array("status" => "failure"));
            }
        }
        return $count;
    }
}

function deleteData($table, $where, $json = true)
{
    global $con;
    $stmt = $con->prepare("DELETE FROM $table WHERE $where");
    $stmt->execute();
    $count = $stmt->rowCount();
    if ($json == true) {
        if ($count > 0) {
            echo json_encode(array("status" => "success"));
        } else {
            echo json_encode(array("status" => "failure"));
        }
    }
    return $count;
}

function imageUpload($dir,$imageRequest)
{
    global $msgError;
    $imagename  = rand(1000, 10000).$_FILES[$imageRequest]['name'];
    $imagetmp   = $_FILES[$imageRequest]['tmp_name'];
    $imagesize  = $_FILES[$imageRequest]['size'];
    $allowExt   = array("jpg", "png", "gif", "mp3", "pdf","jpeg","webp");
    $strToArray = explode(".", $imagename);
    $ext        = end($strToArray);
    $ext        = strtolower($ext);

    if (!empty($imagename) && !in_array($ext, $allowExt)) {
        $msgError = "EXT";
    }
    if ($imagesize > 2 * MB) {
        $msgError = "size";
    }
    if (empty($msgError)) {
        move_uploaded_file($imagetmp, $dir."/".$imagename);
        // print_r($imagename);
        return $imagename;
    } else {
        return "fail";
    }
}



function deleteFile($dir, $imagename)
{
    if (file_exists($dir . "/" . $imagename)) {
        unlink($dir . "/" . $imagename);
    }
}

function checkAuthenticate()
{
    if (isset($_SERVER['PHP_AUTH_USER'])  && isset($_SERVER['PHP_AUTH_PW'])) {
        if ($_SERVER['PHP_AUTH_USER'] != "wael" ||  $_SERVER['PHP_AUTH_PW'] != "wael12345") {
            header('WWW-Authenticate: Basic realm="My Realm"');
            header('HTTP/1.0 401 Unauthorized');
            echo 'Page Not Found';
            exit;
        }
    } else {
        exit;
    }

    // End 
}


function   printFailure($message = "none")
{
    echo     json_encode(array("status" => "failure", "message" => $message));
}
function   printSuccess($message = "none")
{
    echo     json_encode(array("status" => "success", "message" => $message));
}

function result($count)
{
    if ($count > 0) {
        printSuccess();
    } else {
        printFailure();
    }
}

function sendEmail($to, $title, $body)
{
    $header = "From: info@moobashir.com" . "\n" . "CC: aligazi8422@gmail.com";
    mail($to, $title, $body, $header);
}

require 'vendor/autoload.php';
use Aws\S3\S3Client;
use Aws\Exception\AwsException;
function initS3()
{

    $s3 = new S3Client([
        'version' => 'latest',
        'region'  => 'me-south-1',
        'credentials' => [
            'key'    => 'AKIASATQ5ITN6ZF4EUV7',
            'secret' => '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'
        ]
    ]);
    return $s3;
}
function uploadToS3($bucket, $key, $uploadedFile)
{
    $s3 = initS3();
    try {
        $result = $s3->putObject([
            'Bucket' => $bucket,
            'Key'    => $key,
            'Body' => fopen($uploadedFile['tmp_name'], 'rb'),
            'ACL'    => 'public-read',
        ]);
        return $result['ObjectURL'];
    } catch (AwsException $e) {
        echo "Error uploading file: " . $e->getMessage();
        return false;
    }
}
function deleteFromS3($bucket, $key)
{
    $s3 = initS3();
    try {
        $result = $s3->deleteObject([
            'Bucket' => $bucket,
            'Key'    => $key,
        ]);
        return true;
    } catch (AwsException $e) {
        echo "Error deleting file: " . $e->getMessage();
        return false;
    }
}
function getS3Object($bucket, $key)
{
    $s3 = initS3();
    try {
        $result = $s3->getObject([
            'Bucket' => $bucket,
            'Key'    => $key,
        ]);
        return $result['Body'];
    } catch (AwsException $e) {
        echo "Error getting file: " . $e->getMessage();
        return false;
    }
}
